/*
 * This software is contributed or developed by KYOCERA Corporation.
 * (C) 2011 KYOCERA Corporation
 */
#ifndef __LINUX_MONLEY_DEVICE_MODULE_H
#define __LINUX_MONLEY_DEVICE_MODULE_H

#include <linux/ioctl.h>

#define MONKEY_DEVICE_MAGCI_VALUE "MONKEY_MAGIC"

#define MONKEY_DEVICE_MAGIC_SIZE  (12)
#define MONKEY_DEVICE_STOP_SIZE   (4)
#define MONKEY_DEVICE_CYCLE_SIZE  (4)
#define MONKEY_DEVICE_LOG_SIZE    (1024)
#define MONKEY_DEVICE_FILE_SIZE   (128)

#define MONKEY_DEVICE_IOCTL_MAGIC (0xD2)

#define MONKEY_DEVICE_IOCTL_SET_MAGIC    _IOW(MONKEY_DEVICE_IOCTL_MAGIC,  1, unsigned int)
#define MONKEY_DEVICE_IOCTL_RESET_MAGIC  _IOW(MONKEY_DEVICE_IOCTL_MAGIC,  2, unsigned int)
#define MONKEY_DEVICE_IOCTL_GET_MAGIC    _IOR(MONKEY_DEVICE_IOCTL_MAGIC,  3, unsigned int)
#define MONKEY_DEVICE_IOCTL_SET_STOP     _IOW(MONKEY_DEVICE_IOCTL_MAGIC,  4, unsigned int)
#define MONKEY_DEVICE_IOCTL_GET_STOP     _IOR(MONKEY_DEVICE_IOCTL_MAGIC,  5, unsigned int)
#define MONKEY_DEVICE_IOCTL_SET_CYCLE    _IOW(MONKEY_DEVICE_IOCTL_MAGIC,  6, unsigned int)
#define MONKEY_DEVICE_IOCTL_GET_CYCLE    _IOR(MONKEY_DEVICE_IOCTL_MAGIC,  7, unsigned int)
#define MONKEY_DEVICE_IOCTL_SET_LOG      _IOW(MONKEY_DEVICE_IOCTL_MAGIC,  8, unsigned int)
#define MONKEY_DEVICE_IOCTL_GET_LOG      _IOR(MONKEY_DEVICE_IOCTL_MAGIC,  9, unsigned int)
#define MONKEY_DEVICE_IOCTL_SET_FILE     _IOW(MONKEY_DEVICE_IOCTL_MAGIC, 10, unsigned int)
#define MONKEY_DEVICE_IOCTL_GET_FILE     _IOR(MONKEY_DEVICE_IOCTL_MAGIC, 11, unsigned int)

#endif /* __LINUX_MONLEY_DEVICE_MODULE_H */
